.686                       
.model flat, stdcall       
option casemap :none       

    .const
Stack_MAX equ (1024*1024)
FrontF      equ 0
BackF       equ 1
TopF        equ 2
BottomF     equ 3
LeftF       equ 4
RightF      equ 5
NFO         equ 9
    .data?
_Stack      dd ?
_SP         dd ?
_MoveReg    dd ?
_MoveNo     dd ?
_StackOFlag dd ?
_TempCube   dd 7 DUP(?)

NOFF Macro face,block
face*NFO+block
ENDM

MSAVETEMP Macro
mov esi,OFFSET _TempCube
mov eax,[esp+4]
lea edi,[eax*8]
sub edi,eax
lea edi,[edi*4]
add edi,_Stack
mov ecx,7
rep movsd
ENDM

MLOADTEMP Macro
mov eax,[esp+4]
lea esi,[eax*8]
sub esi,eax
lea esi,[esi*4]
add esi,_Stack
mov edi,OFFSET _TempCube
mov ecx,7
rep movsd
ENDM

_axpres dd ?
_bxpres dd ?

    .data
_SucessFlag  db 0
    .code

CycleNibbles MACRO ao,bo,co,do

mov edi,eax
and eax,(0FH SHL (7-ao)*4) ; eax = ~#ao
and edi,-(0FH SHL (7-ao)*4)    ; edi = #ao -> es
mov _axpres,edi

mov edi,ebx
and ebx,(0FH SHL (7-bo)*4) ; ebx = ~#bo
and edi,-(0FH SHL (7-bo)*4)    ; edi = #bo -> fs
mov _bxpres,edi

mov ebp,ecx
and ecx,(0FH SHL (7-co)*4) ; ecx = ~#co
and ebp,-(0FH SHL (7-co)*4)    ; ebp = #co

mov edi,edx
and edx,(0FH SHL (7-do)*4) ; edx = ~#do
and edi,-(0FH SHL (7-do)*4)    ; edi = #do

; Now cycle D->A->B->C->D
or eax,edi  ; D->A
mov edi,_axpres  ; #A
or ebx,edi  ; A->B
or edx,ebp  ; C->D
mov ebp,_bxpres  ; #B
or ecx,ebp  ; B->C

ENDM

Cycle12Nibbles  MACRO       \
    no11,no12,no13,no14,    \
    no21,no22,no23,no24,    \
    no31,no32,no33,no34

mov eax,[esi+(no11/2)];
mov ebx,[esi+(no12/2)];
mov ecx,[esi+(no13/2)];
mov edx,[esi+(no14/2)];
CycleNibbles ((no11) AND (7)),((no12) AND (7)),((no13) AND (7)),((no14) AND (7))
CycleNibbles ((no21) AND (7)),((no22) AND (7)),((no23) AND (7)),((no24) AND (7))
CycleNibbles ((no31) AND (7)),((no32) AND (7)),((no33) AND (7)),((no34) AND (7))
mov [esi+(no11/2)],eax;
mov [esi+(no12/2)],ebx;
mov [esi+(no13/2)],ecx;
mov [esi+(no14/2)],edx;
                        
ENDM

CycleFace MACRO TopF,PerpOut
mov eax,[esi+TopF*9]
mov ebx,[esi+TopF*9+1]
mov ecx,ebx
mov edx,ebx

IF PerpOut
CycleNibbles 0,4,6,0
CycleNibbles 1,1,5,3
and ebx,(0FH SHL (7-4)*4) OR (0FH SHL (7-1)*4)
and ecx,(0FH SHL (7-5)*4) OR (0FH SHL (7-6)*4)
and edx,(0FH SHL (7-0)*4) OR (0FH SHL (7-3)*4)

ELSE
CycleNibbles 0,0,6,4
CycleNibbles 1,3,5,1
and ebx,(0FH SHL (7-0)*4) OR (0FH SHL (7-3)*4)
and ecx,(0FH SHL (7-5)*4) OR (0FH SHL (7-6)*4)
and edx,(0FH SHL (7-4)*4) OR (0FH SHL (7-1)*4)

ENDIF

or  ebx,ecx
or  ebx,edx
mov [esi+TopF*9],eax
mov [esi+TopF*9],ebx
ENDM

_Check_Legal_Move Proc  ; esi = Current Move Structure & CLD ; Iflegal sets zero flag
mov edi,_Stack
mov eax,_SP
mov ebx,esi
jz  getout
mov ecx,7 
ALIGN 16

CmpIt:
cmpsd
jnz ReCmp
dec ecx
jnz CmpIt
mov eax,1
ret

ReCmp:
mov ecx,7
mov esi,ebx
dec eax
jnz CmpIt

getout:
ret
_Check_Legal_Move ENDP

ALIGN 16
RecurseMove Proc
cmp _SP,Stack_MAX-1
jl  OKwork
mov _StackOFlag,1
jmp failret

OKwork: 
mov esi,OFFSET _TempCube
call _Check_Legal_Move
jnz failret
inc _SP
mov eax,_SP
push eax
MSAVETEMP

; Check TempCube for Sucess
TrySucess:
xor ecx,ecx
mov edx,ecx
@CheckF:
mov eax,[esi+edx]
mov bl,[esi+edx+4]
and ebx,0FH
mov edi,ebx
shl edi,4
or  ebx,edi
mov edi,ebx
shl edi,8
or  ebx,edi
mov edi,ebx
shl edi,16
or  ebx,edi
cmp eax,ebx
jne TryMoves
add ecx,9
mov edx,ecx
shr edx,1
cmp ecx,54
jl  @CheckF

PureSucess:
; Sucess! Found the answers
mov _SucessFlag,1
jmp retzflag

TryMoves :

push    _MoveNo
inc     _MoveNo

;;;;;;;;; Test each of the nine possible moves ;;;;;;;;;;;

mov byte ptr [[esp]+_MoveReg],0
Cycle12Nibbles          \   ; X1
(FrontF*9)  ,   (BottomF*9) ,   (BackF*9+8) ,   (TopF*9)    ,   \
(FrontF*9+3),   (BottomF*9+3),  (BackF*9+5) ,   (TopF*9+3)  ,   \
(FrontF*9+6),   (BottomF*9+6),  (BackF*9+2) ,   (TopF*9+6)
CycleFace LeftF,0
call RecurseMove
jz retzflag

inc byte ptr [[esp]+_MoveReg]
MLOADTEMP
Cycle12Nibbles          \   ; X2
(FrontF*9+1),   (BottomF*9+1),  (BackF*9+7) ,   (TopF*9+1)    ,   \
(FrontF*9+4),   (BottomF*9+4),  (BackF*9+4) ,   (TopF*9+4)    ,   \
(FrontF*9+6),   (BottomF*9+6),  (BackF*9+2) ,   (TopF*9+6)
call RecurseMove
jz retzflag

inc byte ptr [[esp]+_MoveReg]
MLOADTEMP
Cycle12Nibbles          \   ; X3
(FrontF*9+2),   (BottomF*9+2),  (BackF*9+6) ,   (TopF*9+2)    ,   \
(FrontF*9+5),   (BottomF*9+5),  (BackF*9+3) ,   (TopF*9+5)    ,   \
(FrontF*9+7),   (BottomF*9+7),  (BackF*9+1) ,   (TopF*9+7)
CycleFace RightF,1
call RecurseMove
jz retzflag

inc byte ptr [[esp]+_MoveReg]
MLOADTEMP
Cycle12Nibbles          \   ; Y1
(FrontF*9)  ,   (LeftF*9)   ,   (BackF*9)   ,   (RightF*9)    ,   \
(FrontF*9+1),   (LeftF*9+1) ,   (BackF*9+1) ,   (RightF*9+1)  ,   \
(FrontF*9+2),   (LeftF*9+2) ,   (BackF*9+2) ,   (RightF*9+2)     
CycleFace TopF,0
call RecurseMove
jz retzflag

inc byte ptr [[esp]+_MoveReg]
MLOADTEMP
Cycle12Nibbles          \   ; Y2
(FrontF*9+3),   (LeftF*9+3),    (BackF*9+3),    (RightF*9+3), \
(FrontF*9+4),   (LeftF*9+4),    (BackF*9+4),    (RightF*9+4), \
(FrontF*9+5),   (LeftF*9+5),    (BackF*9+5),    (RightF*9+5) 
call RecurseMove
jz retzflag

inc byte ptr [[esp]+_MoveReg]
MLOADTEMP
Cycle12Nibbles          \   ; Y3
(FrontF*9+6),   (LeftF*9+6),    (BackF*9+6),    (RightF*9+6), \
(FrontF*9+7),   (LeftF*9+7),    (BackF*9+7),    (RightF*9+7), \
(FrontF*9+8),   (LeftF*9+8),    (BackF*9+8),    (RightF*9+8) 
CycleFace BottomF,1
call RecurseMove
jz retzflag

inc byte ptr [[esp]+_MoveReg]
MLOADTEMP
Cycle12Nibbles          \   ; Z1
(LeftF*9+0)  ,  (TopF*9+0) ,   (RightF*9)   ,   (BottomF*9)    ,   \
(LeftF*9+1)  ,  (TopF*9+1) ,   (RightF*9+1) ,   (BottomF*9+1)  ,   \
(LeftF*9+2)  ,  (TopF*9+2) ,   (RightF*9+2) ,   (BottomF*9+2)     
CycleFace BackF,1
call RecurseMove
jz retzflag

inc byte ptr [[esp]+_MoveReg]
MLOADTEMP
Cycle12Nibbles          \   ; Z2
(LeftF*9+3)  ,  (TopF*9+3) ,   (RightF*9+3) ,   (BottomF*9+3),   \
(LeftF*9+4)  ,  (TopF*9+4) ,   (RightF*9+4) ,   (BottomF*9+4),   \
(LeftF*9+5)  ,  (TopF*9+5) ,   (RightF*9+5) ,   (BottomF*9+5)     
call RecurseMove
jz retzflag

inc byte ptr [[esp]+_MoveReg]
MLOADTEMP
Cycle12Nibbles          \   ; Z3
(LeftF*9+6)  ,  (TopF*9+6) ,   (RightF*9+6) ,   (BottomF*9+6),   \
(LeftF*9+7)  ,  (TopF*9+7) ,   (RightF*9+7) ,   (BottomF*9+7),   \
(LeftF*9+8)  ,  (TopF*9+8) ,   (RightF*9+8) ,   (BottomF*9+8)     
CycleFace FrontF,0
call RecurseMove
jz retzflag

failret:
mov _SucessFlag,0
add esp,8
ret

retzflag:
add esp,8
mov eax,0
ret

RecurseMove ENDP

RunEngine Proc
push ebp
push esi
push edi
push ebx
cld
xor eax,eax
push eax
push eax
MLOADTEMP
add esp,8
call RecurseMove
pop  ebx
pop  edi
pop  esi
pop  ebp
ret
RunEngine ENDP
end